#include <math.h>
#include <stdlib.h>
#include "nrutil.c"
#include "rkck.c"
#include "rtbis.c"


float g, vx0, alf, v0;
int N = 2;
float x0, x1, y21;


void f_shoot_x (float x, float y[], float dyperdx[])
{
										// y[1]: y(x), y[2]: vy(x)
		dyperdx[1] = y[2]/vx0;
		dyperdx[2] = -g/vx0;
	
}


float y_elteres (float alfa)
{
		 float deltay;
	int i, xstep, n, nok, nbad;
	float *y0, eps;

		 deltay = 0.0;
	xstep = 10000;

		y0 = vector (1, N);			// kezdeti ertekek es alapertelmezett ertekei
		y0[1] = 0.0;
		y0[2] = v0*sin(alfa);

		vx0=v0*cos(alfa);


		 kmax = 10000;
		 xp = vector (1, kmax);
		 yp = matrix (1, N, 1, kmax);
		 dxsav = (x1-x0)/100; 
		 eps = 0.00000001;

		 hdone = vector (1, MAXSTP);
		 hwill = vector (1, MAXSTP);
		 for (i=1;i<=MAXSTP;i++)
		 {
			 hdone[i] = 0.0;
			 hwill[i] = 0.0;
		 }
		 
		 odeint(y0, 
				N, 
				x0, 
				x1, 
				eps, 
				(x1-x0)/xstep,
				0, 
				&nok, 
				&nbad,
				f_shoot_x,
				rkqs);

 
		 deltay = yp[1][kount]-y21;

		 free_vector (xp, 1, kmax);
		 free_vector (y0, 1, N);
		 free_matrix (yp, 1, N, 1, kmax);
		 free_vector (hdone, 1, MAXSTP);
		 free_vector (hwill, 1, MAXSTP);


		 return deltay;
}


void main (int argc, char *argv[])
{

	int i, xstep, n, nok, nbad;
	float *y0, eps, sum, alf1, alf2, alfaccuracy;


	x0 = 0.0;
	x1 = 50.0;
	y21 = 10.0;
	xstep = 10000;
	v0 = 100;
	g=9.81;
	alf1 = 45*3.1415927/180;
	alf2 = 10*3.1415927/180;
	alfaccuracy = 0.001;

	for (i=1; i<argc; i++ ){
		
		switch(i){
	    case 1: 
			x0 = atof(argv[i]); 
			break;
		case 2:
			x1 = atof(argv[i]); 
			break;
		case 3:
			y21 = atof(argv[i]); 
			break;
		case 4:
			v0 = atof(argv[i]);
			break;
		case 5:
			alf1 = atof(argv[i]);
			break;
		case 6:
			alf2 = atof(argv[i]);
			break;
		case 7:
			alfaccuracy = atof(argv[i]);
			break;
		} 
	}

	
	alf = rtbis(y_elteres, alf1, alf2, alfaccuracy);	 
	

	y0 = vector (1, N);			// kezdeti ertekek es alapertelmezett ertekei
	y0[1] = 0.0;
	y0[2] = v0*sin(alf);

	vx0=v0*cos(alf);

	
		
		
		
		kmax = 10000;
		 xp = vector (1, kmax);
		 yp = matrix (1, N, 1, kmax);
		 dxsav = (x1-x0)/100; 
		 eps = 0.00000001;

		 hdone = vector (1, MAXSTP);
		 hwill = vector (1, MAXSTP);
		 for (i=1;i<=MAXSTP;i++)
		 {
			 hdone[i] = 0.0;
			 hwill[i] = 0.0;
		 }
		 
		 odeint(y0, 
				N, 
				x0, 
				x1, 
				eps, 
				(x1-x0)/xstep,
				0, 
				&nok, 
				&nbad,
				f_shoot_x,
				rkqs);

		 printf("%f\n", alf/3.1415927*180);
		 
		 for (i=1;i<=kount;i++)
		 {
			
			printf("%f", xp[i]);
			
			for (n=1; n<=N; n++) 
			{	
				printf("\t%f", yp[n][i]);

			}
		 printf("\n");
		 }
		 

		 free_vector (xp, 1, kmax);
		 free_vector (y0, 1, N);
		 free_matrix (yp, 1, N, 1, kmax);
		 free_vector (hdone, 1, MAXSTP);
		 free_vector (hwill, 1, MAXSTP);


}
